// Copyright (c) 2000-2001 Brad Hughes <bhughes@trolltech.com>
//
// Use, modification and distribution is allowed without limitation,
// warranty, or liability of any kind.
//

#ifndef   __audiooutput_h
#define   __audiooutput_h

class OutputALSA;

#include "output.h"
#include <QObject>
extern "C" {
#include <alsa/asoundlib.h>
}
#if defined( Q_OS_WIN32 )
#include <dsound.h>
#include "constants.h"
#endif


class OutputALSA : public Output
{
Q_OBJECT
public:
    OutputALSA(QObject * parent = 0, const QString &d = "/dev/dsp");
    ~OutputALSA();

    bool initialized() const { return inited; }

    bool initialize();
    void configure(long, int, int, int);
    void stop();
    void pause();
    long written();
    long latency();
    void seek(long);
    
    




private:
    // thread run function
    void run();

    // helper functions
    void reset();
    void resetDSP();
    void status();
    void post();
    void sync();

    QString audio_device;

    bool inited,paus,play,user_stop;
    long total_written, current_seconds,bps;
    int lr, lf, lc, lp;
    //alsa
    snd_pcm_t *pcm_handle;  
    snd_pcm_stream_t stream; 
    snd_pcm_hw_params_t *hwparams;
    char *pcm_name;
    //alsa

#if defined(_OS_UNIX_) || defined(Q_OS_UNIX)
    bool do_select;
    int audio_fd;

#elif defined( _OS_WIN32_ ) || defined( Q_OS_WIN32 )
    LPDIRECTSOUND lpds;
    LPDIRECTSOUNDBUFFER lpdsb;
    LPDIRECTSOUNDNOTIFY lpdsn;
    PCMWAVEFORMAT pcmwf;
    Qt::HANDLE hNotifyEvent;
    DSBPOSITIONNOTIFY notifies[ BUFFERBLOCKS ];
    DWORD currentLatency;
/* Not sure we need this
    DSCAPS dsCaps;
*/
#endif

};


#endif // __audiooutout_h
